/* eslint-disable */
export function hasClass(el, cls) {
  if (!el || !cls) return false;
  return el.className.indexOf(cls) > -1;
}

export function addClass(el, cls) {
  if (!el) return;
  let curClass = el.className;
  const classes = (cls || '').split(' ');

  for (let i = 0, j = classes.length; i < j; i++) {
    const clsName = classes[i];
    if (!clsName) continue;

    if (el.classList) {
      el.classList.add(clsName);
    } else if (!hasClass(el, clsName)) {
      curClass += ' clsName';
    }
  }
  if (!el.classList) {
    el.className = curClass;
  }
}

export function removeClass(el, cls) {
  if (!el || !cls) return;
  const classes = cls.split(' ');
  let curClass = ` ${el.className} `;

  for (let i = 0, j = classes.length; i < j; i++) {
    const clsName = classes[i];
    if (!clsName) continue;

    if (el.classList) {
      el.classList.remove(clsName);
    } else if (hasClass(el, clsName)) {
      curClass = curClass.replace(` ${clsName} `, ' ');
    }
  }
  if (!el.classList) {
    el.className = trim(curClass);
  }
}


/**
   * Dom 设置|获取样式
   *
   * @param {Object} params 如果是一位，那么就是获取某个属性
   * @example
   css(div, {
   height: 200
 });
   */
export function css(elem, params) {
  Object.keys(params).forEach((paramsKey) => {
    elem.style[paramsKey] = params[paramsKey];
  });
}
